﻿var associationTabWizard;

$(document).ready(function () {


    //Build the User grid 
    buildGrid();

    //Set the Tool Tip for Add button in Agent toolbar
    $("#userGrid").kendoTooltip({
        filter: ".k-grid-toolbar a.k-grid-add",
        position: "top",
        content: "Click to add new User"
    });

    //#usrMultiselectfilter Event
    $("#usrMultiselectfilter").kendoMultiSelect({
        dataTextField: "text",
        dataValueField: "value",
        change: function (e) {
            var previous = this._savedOld;
            // These are current values.
            var current = this.value();
            // Let's save it for the next time
            saveCurrent(this);

            // The difference between previous and current are removed elements
            var diff = $(previous).not(current).get();
            // get currently applied filters from the Grid.

            var usrdatasourceFilters = $("#userGrid").data("kendoGrid").dataSource;
            var usrfilters = usrdatasourceFilters.filter();

            // get current set of filters, which is supposed to be array.
            // if the object uwfilterswe obtained above is null/undefined, set this to an empty array
            var currentFilters = usrfilters ? usrfilters.filters : [];

            if (usrfilters == null) {
                // finally, the currentFilters array is applied back to the Grid, using "and" logic.
                $("#userGrid").data("kendoGrid").dataSource.filter({
                    logic: "and",
                    filters: currentFilters
                });

                usrfilters = $("#userGrid").data("kendoGrid").dataSource.filter();
            }

            //To Show Inactive
            for (i = 0; i < usrdatasourceFilters.filter().filters.slice().length; i++) {
                if (usrdatasourceFilters.filter().filters[i].field == diff) {
                    usrfilters.filters.splice(i, 1); //Remove cleared Filter from its Position in Filters List
                }
            }
            usrdatasourceFilters.filter(usrfilters)

            if (diff == "IsActive") {
                IsShowActive = false;
                var isActiveButton = $("#userGrid.k-grid-ShowInactive")[0];
                isActiveButton.textContent = "Hide Inactive";
            }

        } //end of #usrMultiselectfilter change Event


    }); // End of User Multiselect


});  // End of Document


//Save the previous filter options before chnage
function saveCurrent(multi) {
    multi._savedOld = multi.value().slice(0);
}

//catch errors from grids
function dataSource_error(args) {
    //alert(e.xhr.responseText); // displays "error"
    if (args.status == 'error') {

        $("#emessage").text(args.xhr.responseText);
    }

    if (args.errors) {
        var grid = $("#userGrid").data("kendoGrid");
        grid.one("dataBinding", function (e) {
            e.preventDefault();

            for (var error in args.errors) {
                showMessage(grid.editable.element, error, args.errors[error].errors);
            }

            //Set focus to error field
            $(".k-edit-form-container #" + error).focus();

        });
    }
}

function showMessage(container, field, errors) {
    var validationMessageTmpl = kendo.template($("#message").html());
    //add the validation message to the form
    container.find("[data-for=" + field + "]").replaceWith($(validationMessageTmpl({ field: field, message: errors[0] })));
    //container.find("[data-valmsg-for=" + field + "],[data-val-msg-for=" + field + "]").replaceWith($(validationMessageTmpl({ field: field, message: errors[0] })))

}


function buildGrid(){

//Get the source of User model and set to Grids  for operations with Crud Services
    var crudServiceBaseUrl = "http://localhost:62232/api/WebApi",
    usrdataSource = new kendo.data.DataSource({
        transport: {
            read: {
                url: crudServiceBaseUrl + "/GetUserData"
            },
            //            create: {
            //                url: crudServiceBaseUrl + "/POSTaddUserData",
            //                type: "POST",
            //                contentType: "application/json",
            //                complete: function (e) {
            //                    if (e.responseJSON.error == undefined)
            //                        $("#userGrid").data("kendoGrid").dataSource.read();
            //                }
            //            },
            //            update: {
            //                url: crudServiceBaseUrl + "/POSTUserData",
            //                type: "POST",
            //                contentType: "application/json",
            //                complete: function (e) {
            //                    if (e.responseJSON.error == undefined)
            //                        $("#userGrid").data("kendoGrid").dataSource.read();
            //                }
            //            },
            parameterMap: function (options, operation) {
                if (operation !== "read" && options.models) {
                    return kendo.stringify(options.models[0]);
                }
            }
        },
        change: function (e) {
            if (e.action == "itemchange") {
                var parentModel = e.items[0].parent().parent();
                parentModel.dirty = true;
            }
        },
        batch: true,
        pageSize: 15,
        serverPaging: false,
        serverFiltering: false,
        serverSorting: false,
        schema: {
            //Define the field which contains the error
            errors: function (response) {
                return response.error;
            },
            model: {
                id: "UserID",
                LastName: "LastName",
                FirstName: "FirstName",
                Email: "Email",
                OfficeNumber: "OfficeNumber",
                MobileNumber: "MobileNumber",
                FaxNumber: "FaxNumber",
                IsActive: "IsActive",
                Roles: "Roles",
                fields: {
                    UserID: { type: "int", validation: { required: true} },
                    LastName: { type: "string", validation: { required: true} },
                    FirstName: { type: "string", validation: { required: true} },
                    Email: { type: "string", validation: { required: true} },
                    OfficeNumber: { type: "string" },
                    MobileNumber: { type: "string" },
                    FaxNumber: { type: "string" },
                    IsActive: { type: "boolean", defaultValue: true }
                }
            }
        }, //Set the Default Inactive filter for the grids
        filter: {
            "field": "IsActive",
            "operator": "IsEqualTo",
            "value": true
        }
    });

    usrdataSource.bind("error", dataSource_error);

  //Set the User Datasource  to Grids and configure the Grids
    $("#userGrid").kendoGrid({
        dataSource: usrdataSource,
        pageable: true,
        height: 500,
        filterable: { extra: false,
            operators: {
                string: {
                    startswith: "Starts with",
                    eq: "Is equal to",
                    neq: "Is not equal to"
                }
            }
        },
        sortable: true,
        pageable: {
            refresh: true,
            pageSizes: [5, 10, 15, 20],
            buttonCount: 5
        },
        resizable: true,
        toolbar: [
                        { name: "create", text: "", title: "create  new" },
                        { name: "ShowInactive", text: "Show Inactive" },
                        { template: $("#usrFiltertemplate").html() }
                 ],
        dataBound: function () {

            var usrmultiselect = $("#usrMultiselectfilter").data("kendoMultiSelect");
            var jsonObj = [];
            var selectedVal = [];
            var usrdatasource = $("#userGrid").data("kendoGrid").dataSource;
            var presentfilters = usrdatasource.filter();

            // get current set of filters, which is supposed to be array.
            // if the object uwfilterswe obtained above is null/undefined, set this to an empty array
            var currentFilters = presentfilters ? presentfilters.filters : [];

            if (presentfilters == null) {
                // finally, the currentFilters array is applied back to the Grid, using "and" logic.
                $("#userGrid").data("kendoGrid").dataSource.filter({
                    logic: "and",
                    filters: currentFilters
                });

                usrdatasource = $("#userGrid").data("kendoGrid").dataSource;
            }

            for (i = 0; i < usrdatasource.filter().filters.slice().length; i++) {
                if (usrdatasource.filter().filters[i].field != "IsActive") {
                    jsonObj.push({
                        text: usrdatasource.filter().filters[i].field,
                        value: usrdatasource.filter().filters[i].field

                    });
                    selectedVal.push(usrdatasource.filter().filters[i].field);
                }
            }

            var localDataSource = new kendo.data.DataSource({ data: jsonObj });
            localDataSource.read();
            usrmultiselect.dataSource = localDataSource;
            usrmultiselect.refresh();
            usrmultiselect.value(selectedVal);

            saveCurrent(usrmultiselect);

        },
        columns: [
                        {
                            width: 35,
                            template: "# if (IsActive == false){# <img class= 'icon' src = '../images/InActive.png' />#} #"

                        },
                        { field: "UserID", title: "UserID", hidden: true
                        },
                        { field: "LastName", title: "Last Name", filterable: {
                            ui: function (element) {
                                element.kendoAutoComplete({
                                    dataSource: usrdataSource.data().toJSON(),
                                    dataTextField: "LastName"
                                })
                            }
                        }
                        },
                        { field: "FirstName", title: "First Name", filterable: {
                            ui: function (element) {
                                element.kendoAutoComplete({
                                    dataSource: usrdataSource.data().toJSON(),
                                    dataTextField: "FirstName"
                                })
                            }
                        }
                        },
                        { field: "Email", title: "User Name", filterable: {
                            ui: function (element) {
                                element.kendoAutoComplete({
                                    dataSource: usrdataSource.data().toJSON(),
                                    dataTextField: "Email"
                                })
                            }
                        }
                        },
                        { field: "IsActive", title: "Status", hidden: true
                        },
                        {
                            command: [
                                        {
                                            name: "edit",
                                            text: {
                                                edit: "Edit",      // This is the localization for Edit button
                                                update: "Save",    // This is the localization for Update button
                                                cancel: "Cancel"   // This is the localization for Cancel button
                                            }
                                        }
                                    ], width: "140px", title: "&nbsp;"
                        }

                  ],

        //Show the Popup Box on Edit or Create a record
        editable: {
            mode: "popup",
            window: { title: "Edit" },
            template: kendo.template($("#popup_editor").html())
        },
        edit: function (e) {
            $("#tabstrip").kendoTabStrip({
                animation: {
                    open: {
                        effects: "fadeIn"
                    }
                }
            });

            //Set the Tab strip Height and width
            $(".k-edit-form-container").parent().width(600).height(525).data("kendoWindow").center();
            $(".k-edit-form-container").width(600);

            //set the window title to "Add" & set focus to Name txt field if it is of New KendoWindow Container
            if (e.model.isNew()) {
                e.container.data("kendoWindow").title("Add");
            }

            //Assign Stylesheet Class ID for Agent Popup on Edit
            e.container.addClass(this.element.attr("id") + "_popup"); 

       
            //Set the Tool Tip for Add button in popup
            $("#roleGrid").kendoTooltip({
                filter: ".k-grid-toolbar a.k-grid-add",
                position: "top",
                content: "Click to add new role"
            });

            //Set Focus to  Name field on form  when clicked Edit on Grid
            e.container.data('kendoWindow').bind('activate', function (e) {
                $(".k-edit-form-container #Email").focus();
            });


            //Set the Role model to Kendo datasource
            roledataSource = new kendo.data.DataSource({
                data: e.model.Roles,
                pageSize: 10,
                serverPaging: false,
                serverFiltering: false,
                serverSorting: false,
                schema: {
                    model: {
                        id: "RoleID",
                        Role: "Role",
                        Type: "Type",
                        fields: {
                            RoleID: { type: "int" },
                            Role: { defaultValue: { Value: "", Text: "" } },
                            Type: { defaultValue: { Value: "", Text: "" } },
                        }
                    }
                }

            });

            buildRoleGrid(e.model);

        } // end of Edit 

    }); //End of userGrid build

} // End of function buildGrid ()




//Build the Role grid under agents Tabstrip
function buildRoleGrid(model) {

    $("#roleGrid").kendoGrid({
        dataSource: roledataSource,
        height: 350,
        sortable: true,
        resizable: true,
        pageable: {
            info: false,
            refresh: true,
            pageSizes: false,
            previousNext: false,
            numeric: false
        },
        toolbar: [
                        { name: "create", text: "" }
                 ],
        columns: [
                              { field: "RoleID", title: "RoleID", hidden: true },
                              { field: "Type.TypeDescription", width: "100px", title: "Type" },
                              { field: "Role.RoleDescription", width: "160px", title: "Role" },
                              { field: "Type.TypeID", title: "TypeID", hidden: true },
                              {
                                  command: [
                                                {
                                                    name: "edit",
                                                    text: {
                                                        edit: "Edit",      // This is the localization for Edit button
                                                        update: "Save",    // This is the localization for Update button
                                                        cancel: "Cancel"   // This is the localization for Cancel button
                                                    }
                                                },
                                                { name: "destroy", text: "Remove" }
                                       ], width: "175px", title: "&nbsp;"
                              }
                     ],
        editable: {
            mode: "popup",
            template: kendo.template($("#wizardpopup_editor").html())
        },
        edit: function (e) {
            $("#tabstripWizard").kendoTabStrip({
                animation: {
                    open: {
                        effects: "fadeIn"
                    }
                }
            });

            //Set the Tab strip Height and width
            $(".k-edit-form-container", e.container).parent().width(588).data("kendoWindow").center();
            $(".k-edit-form-container", e.container).width(588);
            $(".k-popup-edit-form k-window-content", e.container).height(425);

            setRoleType();
            setRole(e, model);

            //tabStrip.enable(tab, tab.hasClass("k-state-disabled"));
            associationTabWizard = $("#tabstripWizard").kendoTabStrip().data("kendoTabStrip");
            if (e.type != "keypress" || kendo.keys.ENTER == e.keyCode) {

                var tab = associationTabWizard.select().next();

                associationTabWizard.enable(tab, tab.hasClass("k-state-disabled"));

            }

        } //End of Role Edit
    });


} //End of Build Role Grid fun()


function nextWizard_click() {

    var validator = $("#roletypeForm").data("kendoValidator");
    if (validator.validate()) {
        
    var tab = associationTabWizard.select().next();

    associationTabWizard.enable(tab, tab.hasClass("k-state-disabled"));

    tab = associationTabWizard.select();

    associationTabWizard.enable(tab, tab.hasClass("k-state-disabled"));

    associationTabWizard.select(associationTabWizard.tabGroup.children("li").eq(1));
    }
}

function backWizard_click() {

    var tab = associationTabWizard.select().prev();

    associationTabWizard.enable(tab, tab.hasClass("k-state-disabled"));

    tab = associationTabWizard.select();

    associationTabWizard.enable(tab, tab.hasClass("k-state-disabled"));

    associationTabWizard.select(associationTabWizard.tabGroup.children("li").eq(0));
}


function setRoleType() {
    //var crudServiceBaseUrl = window.applicationBaseUrl + 'api/WebApi';

    $("#Type").kendoDropDownList({
        dataTextField: "TypeDescription",
        dataValueField: "TypeID",
        autoBind: false,
        optionLabel: "Select Type...",
        dataSource: [
        { TypeDescription: "RoleType1", TypeID: 201 },
        { TypeDescription: "RoleType2", TypeID: 202 },
        { TypeDescription: "RoleType3", TypeID: 203 }
        ],
        index: 1
    });
}


function setRole(e, model) {
    // var crudServiceBaseUrl = window.applicationBaseUrl + 'api/WebApi';

    $("#Role").kendoDropDownList({
        cascadeFrom: "Type",
       // cascadeFromField: "parentId",
        dataTextField: "RoleDescription",
        dataValueField: "RoleID",
        autoBind: false,
        optionLabel: "Select Role...",
        dataSource: {
            data: [
                    { RoleDescription: "Role1", RoleID: 101, TypeID: 201 },
                    { RoleDescription: "Role2", RoleID: 102, TypeID: 202 },
                    { RoleDescription: "Role3", RoleID: 103, TypeID: 202 },
                    { RoleDescription: "Role4", RoleID: 104, TypeID: 202 },
                    { RoleDescription: "Role5", RoleID: 105, TypeID: 203 }
                 ],
            filter: {
                "field": "RoleDescription",
                "operator": function (item) {

                    var data = $("#roleGrid").data("kendoGrid").dataSource.data();

                    var status = true;

                    if (e.model.isNew()) {
                        for (var j = 0; j < data.length; j++) {
                            if (item == data[j].Role.RoleDescription) {
                                status = false;
                                break;
                            }
                        }
                    }

                    return status;
                }
            }
       },
        index: 1
    });
}




