﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using NDatabase;
using MvcUser.Models;
using System.IO;
using NDatabase.Api.Query;
using NDatabase.Api;

namespace MvcUser.Services.UserDataIO
{
        public class UserData
        {
            static string dbFileName = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"bin\User.db");

            public static void IntializeModel()
            {
                UserModel model = new UserModel();
                model.UserID = 1001;
                model.IsActive = true;
                model.Email = "user1@email.com";
                model.FirstName = "userName1";
                model.LastName = "LName1";
                model.OfficeNumber = "1234567890";
                model.MobileNumber = "2345678901";
                model.FaxNumber = "1256G9YUI";

                List<RoleModel> Roles = new List<RoleModel>();

                RoleModel roleModel = new RoleModel();
                roleModel.RoleID = 101;

                roleModel.Role = new Role
                {
                    RoleDescription = "Role1",
                    RoleID = 101
                };

                roleModel.Type = new RoleType
                {
                    TypeDescription = "RoleType1",
                    TypeID = 201
                };

                Roles.Add(roleModel);

                roleModel = new RoleModel();
                roleModel.RoleID = 105;

                roleModel.Role = new Role
                {
                    RoleDescription = "Role5",
                    RoleID = 105
                };

                roleModel.Type = new RoleType
                {
                    TypeDescription = "RoleType3",
                    TypeID = 203
                };

                Roles.Add(roleModel);

                model.Roles = Roles;

                using (var odb = OdbFactory.Open(dbFileName))
                {
                    // Store the object
                    odb.Store(model);
                }

            }

            public static List<UserModel> ReadUsers()
            {
                //IntializeModel();//only one time run for Ndatabase insert
                //retrieve them by classes and by interface
                List<UserModel> resultRecs = new List<UserModel>();
                using (var odb = OdbFactory.Open(dbFileName))
                {
                    var Users = odb.QueryAndExecute<UserModel>();
                    foreach (var obj in Users)
                    {

                        resultRecs.Add(obj);
                    }
                }
                return resultRecs;
            }

        }
    
}